#include "systemc.h"
int foo(){return 0;}

#ifndef GRAVITY_X
#define GRAVITY_X	0
#endif
#ifndef GRAVITY_Y
#define GRAVITY_Y	-9.81*10
#endif
#ifndef MAX_PARTICLES	// particle storage per tile
#define MAX_PARTICLES	100
#endif

#define cutoff  0.01
#define min_r   (cutoff/100)
#define mass    0.01

const int INVALID = -1;	// invalid particle ID (no particle)

typedef struct Particle_t
{
  double 	x, y;	// position
  double 	vx, vy;	// velocity
  double	ax, ay;	// acceleration
  unsigned	color;	// color in hex RGB byte format
  int		id;	// ID (if INVALID, no particle)

  inline friend std::ostream& operator<<(
  std::ostream& os, const Particle_t& co)
  { os << co.x << ' ' << co.y << '\n';
    return os;
  }
} particle_t;

struct Bar {
  int k;
};
class MyModule: public sc_module {

  int nParticlesInUse;
public:

  SC_HAS_PROCESS(MyModule);

  MyModule(sc_module_name mn)
  {
    SC_THREAD(thread);
  }

  void thread()
  {

#if 1
    int k;
    for(int i=0; i<foo();i++) { // not simd
    }

    for(int i=0; i<4;i++) { // simd
    }

    for(int i=0; i<10;i++) { // not simd
      int i = 5;
      switch(i) {
        case 1: i++;
        case 2: i++;
        default: i+=3;
      }
    }

    for(int i=0; i<10;i++) { // not simd
      goto my_label;
    }
my_label:

    for(int i=0; i<10;i++) { // simd
    }

    int j;
    for(int i=0; i<10; i++, j++) { // not simd
      j++;
    }

    for(int i=0; i<10; i++, j++) { // not simd
      i++;
    }

    for(int i=0; i<10; i++, j++) { // not simd
      if(true) {
        i++;
      }
    }
    int not_local;
    for(int i=0; i<10; i++) { // simd // this will be not identified
      if(true) {
        for(int k=0; k<12; k++) { // not simd
          k++;
        }
        for(int k=0; k<12; k++) { // not simd
          k++;
        }
      }
    }

    for(int i=0; i<10; i++) { // not simd
      if(true) {
        for(int k=0; k<12; k++) { // not simd
          k++;
        }
        for(int k=0; k<12; k++) { // not simd
          i++;
        }
      }
    }

    for(int i=0; i<10; i++) { // not simd
      if(true) {
        for(int k=0; k<12; k++) { // not simd
          not_local++;
        }
        for(int k=0; k<12; k++) { // not simd
          i++;
        }
      }
    }

    for(int i=0; i<10; i++) { // not simd
      if(true) {
        for(int k=0; k<12; k++) { // not simd
          k++;
        }
        for(int k=0; k<12; k++) { // not simd
          not_local++;
        }
      }
    }


    int array[10];
    for(int i=0; i<10; i++) { // simd
      array[i]++;
    }

    for(int i=0; i<10; i++) { // not simd
      array[j]++;
    }

    for(int i=0; i<10; i++, j++) { // not simd
      if(true) {
        i++;
      }
    }

    for(int i=0; i<10;i++) { // simd

      if(i < 10) {
        int a;
      }
    }

    for(int i=0; i<10;i++) { // not simd

      if(i < 10) {
        int a;
        switch(a) {
          default:
            int k;
        }
      }
    }

    for(int i=0; i<10;i++) { // not simd

      if(i < 10) {
        int a;
        switch(a) {
          case 1:
            for(int i=0; i<10; i++) { // simd
            }
          default:
            int k;
        }
      }
    }

    int array2[4];
    for(int j=0; j<5; j++) { // simd
      for(int i=0; i<30; i++) { // not simd
        array2[j] = i*j;
      }
    }

    for(int j=0; j<5; j++) { // not simd
      for(int i=0; i<30; i++) { // not simd
        j++;
      }
    }


    int not_local1, not_local2;
    for(int j=0; j<10; j++) { // not simd
      int local =5;


      for(int k=0; k<10; k++) { // not simd
        not_local1++;
      }

      for(int l=0; l<10; l++) { // not simd
        not_local2++;
      }

      local++;
    }


    int array3[10];
    Bar array4[10];

    // no support
    //for(int i=0; i<10; i++) {
    //  array3[i]++;
    //}

    for(int i=0; i<10; i++) {
      array3[i] = 15;
    }

    for(int i=0; i<10; i++) {
      array4[i].k = 15;
    }


#else


    particle_t particles[MAX_PARTICLES];

    for(int i=0; i<nParticlesInUse; i++) {

      if(particles[i].id == INVALID) {
        continue;
      }

      particles[i].ax = GRAVITY_X;
      particles[i].ay = GRAVITY_Y;

    #if 1
      double pix = particles[i].x;
      double piy = particles[i].y;
      double piax = particles[i].ax;
      double piay = particles[i].ay;
    #endif

      for(int j=0; j<nParticlesInUse; j++) {

        if(particles[j].id != INVALID) {
          int I_SHOW_UP;
        #if 1
          double dx = particles[j].x - pix;
          double dy = particles[j].y - piy;
        #else
          double dx = particles[j].x - particles[i].x;
          double dy = particles[j].y - particles[i].y;
        #endif
          double r2 = dx * dx + dy * dy;
          if( r2 > cutoff*cutoff ) {
            //return;
          } else {

          int I_DONT_SHOW_UP;
        #if 1
            r2 = std::max( r2, min_r*min_r );
        #else
            r2 = fmax( r2, min_r*min_r );
        #endif
            double r = sqrt( r2 );
            //
            // very simple short-range repulsive force
            //
            double coef = ( 1 - cutoff / r ) / r2 / mass;
            particles[i].ax += coef * dx;
            particles[i].ay += coef * dy;

        #if 1
            if (piax*piax + piay*piay > 10000000) {
        #else
            if (particles[i].ax*particles[i].ax + particles[i].ay*particles[i].ay > 10000000) {
        #endif
              particles[i].ax = 0;
              particles[i].ay = 0;
            }
          }
        }
      }
    }
#endif
  }
};

int sc_main(int argc, char **argv)
{
  MyModule m("m");
  sc_start();
  return 0;
}
