#include "module_instance.h"

risc::ModuleInstance::ModuleInstance(
    SgVariableDefinition *ast_node,
    Module *ir_def):
  Instance(ast_node, ModuleInstanceType),
  module_definition_(ir_def)
{
  assert(ir_def);
  module_definition_->instances_.push_back(this);
}

risc::ModuleInstance::ModuleInstance(
    SgVariableDefinition *ast_node,
    Type type):
  Instance(ast_node, type),
  module_definition_(NULL)
{ }

risc::Module* risc::ModuleInstance::get_definition()
{
  return module_definition_;
}

void risc::ModuleInstance::add_mapping(Port *port, Object *object)
{
  mapping_.insert(std::make_pair(port, object));
}

std::string risc::ModuleInstance::get_instance_qualified_name()
{
  return get_ast_node()->get_declaration()->get_decl_item(0)->get_qualified_name();
}
/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
