#ifndef PORT_CALL_PATH_H_INCLUDED_
#define PORT_CALL_PATH_H_INCLUDED_

#include "rose.h"

namespace risc {

namespace sg {

class PortCallPath {

public:
  std::list<SgFunctionCallExp*> path_;

  //2018 07 18 ZC
  //for pcp+psg, details refer to change_logs_ZC 1)
  SgVariableDefinition* port_;
  int pcp_type_; 

  PortCallPath();
  ~PortCallPath();
};

bool operator==(const PortCallPath &lhs , const PortCallPath &rhs);

struct SymbolWithPath {
  SgVariableSymbol *symbol_;
  PortCallPath pcp_;

  SymbolWithPath(SgVariableSymbol* symbol, PortCallPath pcp):
    symbol_(symbol),
    pcp_(pcp)
  { }
};

struct NodeWithPath {
  SgNode *node_;
  PortCallPath pcp_;

  NodeWithPath(SgNode* node, PortCallPath pcp):
    node_(node),
    pcp_(pcp)
  { }
};

} // end of namespace sg

} // end of namespace risc

#endif /* PORT_CALL_PATH_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
