#ifndef FILE_CLASSIFIER_H_INCLUDED_
#define FILE_CLASSIFIER_H_INCLUDED_

#include "rose.h"

namespace risc
{

namespace tools
{

Rose::StringUtility::FileNameLibrary get_library(int file_id);
Rose::StringUtility::FileNameLibrary get_library(Sg_File_Info* X);

struct UserSpaceFilter:
  public std::unary_function<bool,SgFunctionDeclaration*> {

  bool operator() (SgFunctionDeclaration* node) const
  {
    if(node->get_definingDeclaration()) {

      if(get_library(node->get_definingDeclaration()->get_file_info()) ==
          "User") {

        return true;
      }
    }

    if(get_library(node->get_file_info()) == "User") {

      return true;
    } else {
      return false;
    }
  }
};

} // end namespace tools

} // end namespace risc

#endif /* FILE_CLASSIFIER_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
