#include "systemc.h"

int global;
int global2;

class A: public sc_module {

public:
  int &a_ref; // variable in the middle var in Top
  int &a_ref2; // variable in B var2 in B
  int &a_ref3; // passing only by refernce var2 in Top
  int &a_ref4; // global variable
  int &a_ref5; // global variable2
  int a_value;
  sc_event &a_event;

  A(sc_module_name mn, int &a_ref_param, int a_value_param, int &a_ref_param2,
      sc_event &a_event_param, int &a_ref_param3, int &a_ref_param4,
      int &a_ref_param5):
    sc_module(mn),
    a_ref(a_ref_param),
    a_value(a_value_param),
    a_ref2(a_ref_param2),
    a_event(a_event_param),
    a_ref3(a_ref_param3),
    a_ref4(a_ref_param4),
    a_ref5(a_ref_param5)
  { }
};

class B: public sc_module {

public:
  A a1;
  A a2;
  A a3;

  int &b_ref;
  sc_event &event_ref;

  int var2, var3, var4, var5, var6;

  B(sc_module_name mn, int &b_ref_param, sc_event &b_event_param,
      int &b_ref_param2, int &b_ref_param3):
    sc_module(mn),
    b_ref(b_ref_param),
    event_ref(b_event_param),
    a1("a1", b_ref, 5, var4, event_ref, b_ref_param2, b_ref_param3, global2),
    a2("a2", var2, 5, var5, event_ref, b_ref_param2, b_ref_param3, global2),
    a3("a3", var3, 5, var6, event_ref, b_ref_param2, b_ref_param3, global2)
  { }
};

class C: public sc_module {

public:
  B b;
  int &c_ref;
  sc_event &event_ref;

  C(sc_module_name mn, int &c_ref_param, sc_event &c_event_param,
      int &c_ref_param3, int &c_ref_param4):
    sc_module(mn),
    c_ref(c_ref_param),
    event_ref(c_event_param),
    b("b", c_ref, event_ref, c_ref_param3, c_ref_param4)
  { }
};

class D: public sc_module {

public:
  int &d_ref;
  D(sc_module_name mn, int &d_ref_param):
    sc_module(mn),
    d_ref(d_ref_param)
  { }
};

class E: public sc_module {

public:
  D d;

  E(sc_module_name mn, int &e_ref_param):
    sc_module(mn),
    d("d", e_ref_param)
  { }
};

class F: public sc_module {

public:
  E e;

  F(sc_module_name mn, int &f_ref_param):
    sc_module(mn),
    e("e", f_ref_param)
  { }
};

class Top: public sc_module {

public:
  int var;
  int var2;
  sc_event top_event;

  C c;
  F f;

  Top(sc_module_name mn):
    sc_module(mn),
    c("c", var, top_event, var2, global),
    f("f", var)
  { }
};



class Testbench: public sc_module {

public:
  Top top;
  Testbench(sc_module_name mn):
    top("top")
  { }
};


int sc_main(int argc, char**argv)
{
  Testbench tb("tb");

  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
