// event_lists.cc:
//
// 07/10/18 RD	extended for a simple case of static sensitivity (v043)
// 06/26/18 RD	extended version of event_and/or_list examples

#include <assert.h>
#include "systemc.h"

#define T 3

SC_MODULE(Top) {
	sc_event e0, e1, e2, e3, e4, e5, e6, e7, e8, e9;
	sc_event_and_list AndList1, AndList5, AndList10;
	sc_event_or_list OrList1, OrList5, OrList10;
	int n0, n1, n2, n3, n4, n5, n6, n7, n8, n9;
	int w0, w1, w2, w3, w4, w5, w6, w7, w8, w9;
	int w;
	int wal1, wal5, wal10;
	int wol1, wol5, wol10;
	int wa23, wa456, wa7890, wa0123456789;
	int wo23, wo456, wo7890, wo0123456789;
	int wxa, wxo;
	sc_time tn0, tn1, tn2, tn3, tn4, tn5, tn6, tn7, tn8, tn9;
	sc_time tw0, tw1, tw2, tw3, tw4, tw5, tw6, tw7, tw8, tw9;
	sc_time tw;
	sc_time twal1, twal5, twal10;
	sc_time twol1, twol5, twol10;
	sc_time twa23, twa456, twa7890, twa0123456789;
	sc_time two23, two456, two7890, two0123456789;
	sc_time twxa, twxo;

	SC_CTOR(Top) {
		n0 = n1 = n2 = n3 = n4 = n5 = n6 = n7 = n8 = n9 = 0;
		w0 = w1 = w2 = w3 = w4 = w5 = w6 = w7 = w8 = w9 = 0;
		w = 0;
		wal1 = wal5 = wal10 = 0;
		wol1 = wol5 = wol10 = 0;
		wa23 = wa456 = wa7890 = wa0123456789 = 0;
		wo23 = wo456 = wo7890 = wo0123456789 = 0;
		wxa = wxo = 0;
		tn0 = tn1 = tn2 = tn3 = tn4 = tn5 = tn6 = tn7 = tn8 = tn9 = SC_ZERO_TIME;
		tw0 = tw1 = tw2 = tw3 = tw4 = tw5 = tw6 = tw7 = tw8 = tw9 = SC_ZERO_TIME;
		tw = SC_ZERO_TIME;
		twal1 = twal5 = twal10 = SC_ZERO_TIME;
		twol1 = twol5 = twol10 = SC_ZERO_TIME;
		twa23 = twa456 = twa7890 = twa0123456789 = SC_ZERO_TIME;
		two23 = two456 = two7890 = two0123456789 = SC_ZERO_TIME;
		twxa = twxo = SC_ZERO_TIME;
		SC_THREAD(notifier0);
		SC_THREAD(notifier1);
		SC_THREAD(notifier2);
		SC_THREAD(notifier3);
		SC_THREAD(notifier4);
		SC_THREAD(notifier5);
		SC_THREAD(notifier6);
		SC_THREAD(notifier7);
		SC_THREAD(notifier8);
		SC_THREAD(notifier9);
		SC_THREAD(waiter0);
		SC_THREAD(waiter1);
		SC_THREAD(waiter2);
		SC_THREAD(waiter3);
		SC_THREAD(waiter4);
		SC_THREAD(waiter5);
		SC_THREAD(waiter6);
		SC_THREAD(waiter7);
		SC_THREAD(waiter8);
		SC_THREAD(waiter9);
		SC_THREAD(waiter);
			sensitive << e3; // NEW in RISC043:
			sensitive << e7; // static sensitivity for threads!
		SC_THREAD(waiter_al1);
		SC_THREAD(waiter_al5);
		SC_THREAD(waiter_al10);
		SC_THREAD(waiter_ol1);
		SC_THREAD(waiter_ol5);
		SC_THREAD(waiter_ol10);
		SC_THREAD(waiter_a23);
		SC_THREAD(waiter_a456);
		SC_THREAD(waiter_a7890);
		SC_THREAD(waiter_a0123456789);
		SC_THREAD(waiter_o23);
		SC_THREAD(waiter_o456);
		SC_THREAD(waiter_o7890);
		SC_THREAD(waiter_o0123456789);
		SC_THREAD(waiter_xa);
		SC_THREAD(waiter_xo);
	}

	void before_end_of_elaboration() {
	// RISC supports static analysis of straightforward event lists here!
		AndList1 &= e0;
		AndList5 &= e0; // not supported: AndList5 = e0;
		AndList5 &= e1;
		AndList5 &= e2;
		AndList5 &= e3;
		AndList5 &= e4;
		AndList10 &= e0; // not supported: AndList10 = AndList5;
		AndList10 &= e1;
		AndList10 &= e2 & e3 & e4;
		AndList10 &= e5 & e6 & e7 & e8 & e9;
		OrList1 |= e0;
		OrList5 |= e0; // not supported: OrList5  = e0;
		OrList5 |= e1;
		OrList5 |= e2;
		OrList5 |= e3;
		OrList5 |= e4;
		OrList10 |= e0; // not supported: OrList10 = OrList5;
		OrList10 |= e1 | (e2 | (e3 | e4));
		OrList10 |= e5 | ((e6 | e7) | (e8 | e9));
	}

	void notifier0() {
		for(int i=0; i<T; i+=1) {
			wait(0,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e0.notify!\n";
			e0.notify(SC_ZERO_TIME);
			n0++;
		}
		tn0 = sc_time_stamp();
	}

	void notifier1() {
		for(int i=0; i<T; i+=1) {
			wait(1,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e1.notify!\n";
			e1.notify(SC_ZERO_TIME);
			n1++;
		}
		tn1 = sc_time_stamp();
	}

	void notifier2() {
		for(int i=0; i<T; i+=1) {
			wait(2,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e2.notify!\n";
			e2.notify(SC_ZERO_TIME);
			n2++;
		}
		tn2 = sc_time_stamp();
	}

	void notifier3() {
		for(int i=0; i<T; i+=1) {
			wait(3,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e3.notify!\n";
			e3.notify(SC_ZERO_TIME);
			n3++;
		}
		tn3 = sc_time_stamp();
	}

	void notifier4() {
		for(int i=0; i<T; i+=1) {
			wait(4,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e4.notify!\n";
			e4.notify(SC_ZERO_TIME);
			n4++;
		}
		tn4 = sc_time_stamp();
	}

	void notifier5() {
		for(int i=0; i<T; i+=1) {
			wait(5,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e5.notify!\n";
			e5.notify(SC_ZERO_TIME);
			n5++;
		}
		tn5 = sc_time_stamp();
	}

	void notifier6() {
		for(int i=0; i<T; i+=1) {
			wait(6,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e6.notify!\n";
			e6.notify(SC_ZERO_TIME);
			n6++;
		}
		tn6 = sc_time_stamp();
	}

	void notifier7() {
		for(int i=0; i<T; i+=1) {
			wait(7,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e7.notify!\n";
			e7.notify(SC_ZERO_TIME);
			n7++;
		}
		tn7 = sc_time_stamp();
	}

	void notifier8() {
		for(int i=0; i<T; i+=1) {
			wait(8,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e8.notify!\n";
			e8.notify(SC_ZERO_TIME);
			n8++;
		}
		tn8 = sc_time_stamp();
	}

	void notifier9() {
		for(int i=0; i<T; i+=1) {
			wait(9,SC_NS);
			std::cout << sc_time_stamp().to_string() << ": e9.notify!\n";
			e9.notify(SC_ZERO_TIME);
			n9++;
		}
		tn9 = sc_time_stamp();
	}

	void waiter0() {
		wait(e0);
		std::cout << sc_time_stamp().to_string() << ": wait(e0) done!\n";
		w0 = 1;
		tw0 = sc_time_stamp();
	}

	void waiter1() {
		wait(e1);
		std::cout << sc_time_stamp().to_string() << ": wait(e1) done!\n";
		w1 = 1;
		tw1 = sc_time_stamp();
	}

	void waiter2() {
		wait(e2);
		std::cout << sc_time_stamp().to_string() << ": wait(e2) done!\n";
		w2 = 1;
		tw2 = sc_time_stamp();
	}

	void waiter3() {
		wait(e3);
		std::cout << sc_time_stamp().to_string() << ": wait(e3) done!\n";
		w3 = 1;
		tw3 = sc_time_stamp();
	}

	void waiter4() {
		wait(e4);
		std::cout << sc_time_stamp().to_string() << ": wait(e4) done!\n";
		w4 = 1;
		tw4 = sc_time_stamp();
	}

	void waiter5() {
		wait(e5);
		std::cout << sc_time_stamp().to_string() << ": wait(e5) done!\n";
		w5 = 1;
		tw5 = sc_time_stamp();
	}

	void waiter6() {
		wait(e6);
		std::cout << sc_time_stamp().to_string() << ": wait(e6) done!\n";
		w6 = 1;
		tw6 = sc_time_stamp();
	}

	void waiter7() {
		wait(e7);
		std::cout << sc_time_stamp().to_string() << ": wait(e7) done!\n";
		w7 = 1;
		tw7 = sc_time_stamp();
	}

	void waiter8() {
		wait(e8);
		std::cout << sc_time_stamp().to_string() << ": wait(e8) done!\n";
		w8 = 1;
		tw8 = sc_time_stamp();
	}

	void waiter9() {
		wait(e9);
		std::cout << sc_time_stamp().to_string() << ": wait(e9) done!\n";
		w9 = 1;
		tw9 = sc_time_stamp();
	}

	void waiter() {
	// new support in RISC v0.4.3: static sensitivity!
		wait(/*nothing*/); // wait for sensitive events, i.e. e3 or e7
		std::cout << sc_time_stamp().to_string() << ": wait() done!\n";
		w = 1;
		tw = sc_time_stamp();
	}

	void waiter_al1() {
		wait(AndList1);
		std::cout << sc_time_stamp().to_string() << ": wait(AndList1) done!\n";
		wal1 = 1;
		twal1 = sc_time_stamp();
	}

	void waiter_al5() {
		wait(AndList5);
		std::cout << sc_time_stamp().to_string() << ": wait(AndList5) done!\n";
		wal5 = 1;
		twal5 = sc_time_stamp();
	}

	void waiter_al10() {
		wait(AndList10);
		std::cout << sc_time_stamp().to_string() << ": wait(AndList10) done!\n";
		wal10 = 1;
		twal10 = sc_time_stamp();
	}

	void waiter_ol1() {
		wait(OrList1);
		std::cout << sc_time_stamp().to_string() << ": wait(OrList1) done!\n";
		wol1 = 1;
		twol1 = sc_time_stamp();
	}

	void waiter_ol5() {
		wait(OrList5);
		std::cout << sc_time_stamp().to_string() << ": wait(OrList5) done!\n";
		wol5 = 1;
		twol5 = sc_time_stamp();
	}

	void waiter_ol10() {
		wait(OrList10);
		std::cout << sc_time_stamp().to_string() << ": wait(OrList10) done!\n";
		wol10 = 1;
		twol10 = sc_time_stamp();
	}

	void waiter_a23() {
		wait(e2 & e3);
		std::cout << sc_time_stamp().to_string() << ": wait(e2 & e3) done!\n";
		wa23 = 1;
		twa23 = sc_time_stamp();
	}

	void waiter_a456() {
		wait(e4 & e5 & e6);
		std::cout << sc_time_stamp().to_string() << ": wait(e4 & e5 & e6) done!\n";
		wa456 = 1;
		twa456 = sc_time_stamp();
	}

	void waiter_a7890() {
		wait(e7 & e8 & e9 & e0);
		std::cout << sc_time_stamp().to_string() << ": wait(e7 & e8 & e9 & e0) done!\n";
		wa7890 = 1;
		twa7890 = sc_time_stamp();
	}

	void waiter_a0123456789() {
		wait(e0 & e1 & e2 & e3 & e4 & e5 & e6 & e7 & e8 & e9);
		std::cout << sc_time_stamp().to_string() << ": wait(e0 & e1 & e2 & e3 & e4 & e5 & e6 & e7 & e8 & e9) done!\n";
		wa0123456789 = 1;
		twa0123456789 = sc_time_stamp();
	}

	void waiter_o23() {
		wait(e2 | e3);
		std::cout << sc_time_stamp().to_string() << ": wait(e2 | e3) done!\n";
		wo23 = 1;
		two23 = sc_time_stamp();
	}

	void waiter_o456() {
		wait(e4 | e5 | e6);
		std::cout << sc_time_stamp().to_string() << ": wait(e4 | e5 | e6) done!\n";
		wo456 = 1;
		two456 = sc_time_stamp();
	}

	void waiter_o7890() {
		wait(e7 | e8 | e9 | e0);
		std::cout << sc_time_stamp().to_string() << ": wait(e7 | e8 | e9 | e0) done!\n";
		wo7890 = 1;
		two7890 = sc_time_stamp();
	}

	void waiter_o0123456789() {
		wait(e0 | e1 | e2 | e3 | e4 | e5 | e6 | e7 | e8 | e9);
		std::cout << sc_time_stamp().to_string() << ": wait(e0 | e1 | e2 | e3 | e4 | e5 | e6 | e7 | e8 | e9) done!\n";
		wo0123456789 = 1;
		two0123456789 = sc_time_stamp();
	}

	void waiter_xa() {
		wait(e5 & e6 & AndList5 & (e7 & e8 & e9));
		std::cout << sc_time_stamp().to_string() << ": wait(e5 & e6 & AndList5 & (e7 & e8 & e9)) done!\n";
		wxa = 1;
		twxa = sc_time_stamp();
	}

	void waiter_xo() {
		wait(e5 | e6 | OrList5 | (e7 | e8 | e9));
		std::cout << sc_time_stamp().to_string() << ": wait(e5 | e6 | OrList5 | (e7 | e8 | e9)) done!\n";
		wxo = 1;
		twxo = sc_time_stamp();
	}
};

int sc_main(int argc, char** argv) {
	Top top("top");
	const sc_time tn0(0*T, SC_NS);
	const sc_time tn1(1*T, SC_NS);
	const sc_time tn2(2*T, SC_NS);
	const sc_time tn3(3*T, SC_NS);
	const sc_time tn4(4*T, SC_NS);
	const sc_time tn5(5*T, SC_NS);
	const sc_time tn6(6*T, SC_NS);
	const sc_time tn7(7*T, SC_NS);
	const sc_time tn8(8*T, SC_NS);
	const sc_time tn9(9*T, SC_NS);
	const sc_time tw0(0*T, SC_NS);
	const sc_time tw1(1, SC_NS);
	const sc_time tw2(2, SC_NS);
	const sc_time tw3(3, SC_NS);
	const sc_time tw4(4, SC_NS);
	const sc_time tw5(5, SC_NS);
	const sc_time tw6(6, SC_NS);
	const sc_time tw7(7, SC_NS);
	const sc_time tw8(8, SC_NS);
	const sc_time tw9(9, SC_NS);
	const sc_time tw(3, SC_NS);
	const sc_time twal1(0, SC_NS);
	const sc_time twal5(4, SC_NS);
	const sc_time twal10(9, SC_NS);
	const sc_time twol1(0, SC_NS);
	const sc_time twol5(0, SC_NS);
	const sc_time twol10(0, SC_NS);
	const sc_time twa23(3, SC_NS);
	const sc_time twa456(6, SC_NS);
	const sc_time twa7890(9, SC_NS);
	const sc_time twa0123456789(9, SC_NS);
	const sc_time two23(2, SC_NS);
	const sc_time two456(4, SC_NS);
	const sc_time two7890(0, SC_NS);
	const sc_time two0123456789(0, SC_NS);
	const sc_time twxa(9, SC_NS);
	const sc_time twxo(0, SC_NS);

	cout << "event_lists starts" << endl;
	sc_start();
	assert(top.n0 == T);
	assert(top.n1 == T);
	assert(top.n2 == T);
	assert(top.n3 == T);
	assert(top.n4 == T);
	assert(top.n5 == T);
	assert(top.n6 == T);
	assert(top.n7 == T);
	assert(top.n8 == T);
	assert(top.n9 == T);
	assert(top.w0 == 1);
	assert(top.w1 == 1);
	assert(top.w2 == 1);
	assert(top.w3 == 1);
	assert(top.w4 == 1);
	assert(top.w5 == 1);
	assert(top.w6 == 1);
	assert(top.w7 == 1);
	assert(top.w8 == 1);
	assert(top.w9 == 1);
	assert(top.w == 1);
	assert(top.wal1 == 1);
	assert(top.wal5 == 1);
	assert(top.wal10 == 1);
	assert(top.wol1 == 1);
	assert(top.wol5 == 1);
	assert(top.wol10 == 1);
	assert(top.wa23 == 1);
	assert(top.wa456 == 1);
	assert(top.wa7890 == 1);
	assert(top.wa0123456789 == 1);
	assert(top.wo23 == 1);
	assert(top.wo456 == 1);
	assert(top.wo7890 == 1);
	assert(top.wo0123456789 == 1);
	assert(top.wxa == 1);
	assert(top.wxo == 1);
	assert(top.tn0 == tn0);
	assert(top.tn1 == tn1);
	assert(top.tn2 == tn2);
	assert(top.tn3 == tn3);
	assert(top.tn4 == tn4);
	assert(top.tn5 == tn5);
	assert(top.tn6 == tn6);
	assert(top.tn7 == tn7);
	assert(top.tn8 == tn8);
	assert(top.tn9 == tn9);
	assert(top.tw0 == tw0);
	assert(top.tw1 == tw1);
	assert(top.tw2 == tw2);
	assert(top.tw3 == tw3);
	assert(top.tw4 == tw4);
	assert(top.tw5 == tw5);
	assert(top.tw6 == tw6);
	assert(top.tw7 == tw7);
	assert(top.tw8 == tw8);
	assert(top.tw9 == tw9);
	assert(top.tw == tw);
	assert(top.twal1 == twal1);
	assert(top.twal5 == twal5);
	assert(top.twal10 == twal10);
	assert(top.twol1 == twol1);
	assert(top.twol5 == twol5);
	assert(top.twol10 == twol10);
	assert(top.twa23 == twa23);
	assert(top.twa456 == twa456);
	assert(top.twa7890 == twa7890);
	assert(top.twa0123456789 == twa0123456789);
	assert(top.two23 == two23);
	assert(top.two456 == two456);
	assert(top.two7890 == two7890);
	assert(top.two0123456789 == two0123456789);
	assert(top.twxa == twxa);
	assert(top.twxo == twxo);
	cout << "event_lists done." << endl;
	return 0;
}

/* ex: set softtabstop=8 tabstop=8 shiftwidth=8: */
